#if defined _rindy_included
  #endinput
#endif
#define _rindy_included

stock isnumeric(string[],&num) {
    new i = strlen(string);
    new f = 1;
    new n = 0;
    while(i > 0) {
        i--;
        if('0' <= string[i] <= '9') {
            n += (string[i] - '0') * f;
            f *= 10;
        } else {
            return 0;
        }
    }
    num = n;
    return 1;
}

stock abs(num) { //Returns the positive value of num.
    if(num > 0) {
        return num;
    }
    return -num;
}

stock pow(num,exp) { //Returns the power of num with exp.
    new p = num;
    new i;
    if(exp < 0) {
        return -1;
    } else if(exp == 0) {
        return 1;
    } else {
        for(i=1;i<exp;i++) {
            p *= num;
        }
    }
    return p;
}

stock sqrt(num) { //Returns the approximate square root of num.
    new div = num;
    new result = 1;
    if(num >= 0) {
        while(div > result) {
            div = (div + result) / 2;
            result = num / div;
        }
        return div;
    }
    return -1;
}

stock get_accesslevel(sTarget[] = "") {
    new i,j;
    for(i=1;i<=131072;i<<=1) {
        if(access(i,sTarget) ==1) {
            j &= i;
        }
    }
    return j;
}

stock format_lines(Text[],maxlen,linelen = 79) { //Inserts linebreaks into Text for maxlen characters, so no line gets longer than linelen characters, if possible at a space. Returns length of resulting string.
    new SayText[512];
    new textpos;
    new saytextpos;
    new textlen = min(maxlen,strlen(Text));
    new numtoadd;
    new i;
    while(textlen-textpos > linelen) {
        for(i=textpos+linelen;i>textpos;--i) {
            if(Text[i] == '^n' || Text[i] == ' ' && textpos == numtoadd) {
                numtoadd = i;
            }
        }
        if(numtoadd == textpos) {
            numtoadd = textpos+linelen-1;
        }
        for(i=textpos;i<numtoadd;i++) {
            SayText[saytextpos++] = Text[i];
        }
        SayText[saytextpos++] = '^n';
        if(Text[numtoadd] == ' ' || Text[numtoadd] == '^n') {
            numtoadd++;
        }
        textpos = numtoadd;
    }
    for(i=textpos;i<textlen;i++) {
        SayText[saytextpos++] = Text[i];
    }
    saytextpos = min(saytextpos,maxlen);
    for(i=0;i<saytextpos;i++) {
        Text[i] = SayText[i];
    }
    Text[saytextpos] = '^0';
    return saytextpos;
}

#define MSG_CONSOLE 1<<0
#define MSG_CENTER 1<<1
#define MSG_CHAT 1<<2
#define MSG_TSAY 1<<3
#define MSG_CSAY 1<<4
#define MSG_LOG 1<<5

stock print_message(msg[MAX_TEXT_LENGTH],UserIndex = 0,Type = 0) {
    new Name[MAX_NAME_LENGTH];
    new Text[MAX_TEXT_LENGTH];
    new maxplayers = maxplayercount();
    new dummy;
    new i,j;
    strcpy(Text,msg,MAX_TEXT_LENGTH);
    for(i=0;i<5;i++) {
        dummy = Type & 1<<i;
        if(dummy) {
            dummy &= MSG_TSAY | MSG_CSAY;
            if(dummy) {
                format_lines(Text,MAX_TEXT_LENGTH,79);
            }
            if(UserIndex == 0) {
                for(j=1;j<=maxplayers;j++) {
                    if(playerinfo(i,Name,MAX_NAME_LENGTH) == 1) {
                        messageex(Name,Text,i);
                    }
                }
            } else {
                if(playerinfo(UserIndex,Name,MAX_NAME_LENGTH) == 1) {
                    messageex(Name,Text,i);
                }
            }
        }
    }
    dummy = Type & MSG_LOG;
    if(dummy) log(msg);
}